(in-package  :examples)
(use-package :oli)

(sd-defdialog 'mm-geaenderte-objekte
;  :toolbox-button nil
  :dialog-control :sequential
  :dialog-title "Genderte Objekte"
;  :toolbox-button t
  :ok-action
  '(let (geaendertenobjekteliste input-stream input-line zeile zaehler)
     (progn
       ;; Dateiname
       (setf datei "C:/Temp/SD__Strukturliste.txt")
;       (setf datei "P:/Strukturliste.doc")
       ;; Baum-Details anzeigen
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :show-tree-details t)

       ;; Ansicht ruecksetzen
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :expand-tree 1)

       ;; Ansichtenstze, Features, ... ausschalten. Nur Teile, Behaelter und AEs an.
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :layout-mode nil)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :coord_sys-mode nil)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :docu_plane-mode nil)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :group-mode nil)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :feature-mode nil)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :rel_set-mode nil)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :study-mode nil)

       ;; Ansicht expandieren
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :expand-tree 0)
       ;; Baum schreiben
       (sd-browser-print-tree
         "parcel-gbrowser"
         :file        datei ;; fuer UNIX --> "/tmp/SD__Strukturliste.txt"
         :mode        :overwrite
         ;;:start-node  node
       )

       ;; Ansicht ruecksetzen
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :expand-tree 1)

       ;; Ansichtenstze, Features, ... ausschalten. Nur Teile, Behaelter und AEs an.
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :layout-mode t)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :coord_sys-mode t)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :docu_plane-mode t)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :group-mode t)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :feature-mode t)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :rel_set-mode t)
       (g-browser::sd-browser-exec-cmd "parcel-gbrowser" :SET-BROWSER-MODE :study-mode t)

       ;; Baum einlesen, nach geanderten Eintraegen in den Baum-Details suchen und diese in eine Liste schreiben
       (setf geaendertenobjekteliste nil)
       (setf input-stream
         (open datei :direction :input) ;; fuer UNIX --> "/tmp/SD__Strukturliste.txt"
       )
       (loop
         (setf input-line (read-line input-stream nil 'eof))
         (if (eq input-line 'eof)
           (progn
             (close input-stream)
             (return) ;; Ausstieg, wenn keine Zeile mehr vorhanden.
           )
           (when (sd-string-match-pattern-p "*(*: ?nd :*)" input-line)
             (push (format nil "~a" input-line) geaendertenobjekteliste)
           )
         )
       )
       ;; Ausgabe der Pruefung
       (if geaendertenobjekteliste
         (progn
           (display :clear-hide)
           (display "---------------------------------------------------")
           (display (format nil "Anzahl der genderten Objekte: ~a" (list-length geaendertenobjekteliste)))
           (display "---------------------------------------------------")
           (setf zaehler 1)
           (dolist (zeile geaendertenobjekteliste)
             (progn
               (display (format nil "~a" (sd-string-replace (sd-string-trim zeile) "|--" (format nil "[~a/~a]--> " zaehler (list-length geaendertenobjekteliste)))))
               (setf zaehler (+ zaehler 1))
             )
           )
           (display "---------------------------------------------------")
         )
         (progn
           (sd-display-message
             "Keine genderten Objekte gefunden."
             :title "MM-Genderte Objekte"
             :push "OK"
           )
         )
       )
     )
   )
)
